//--------------------------------------------------------------------------------------
//
//	O㍶E㉺̂Uʂ`悵Ăgĉ`
//	by Caeru
//
//--------------------------------------------------------------------------------------

#define			RT_SIZE					640

float			s_fTr					: CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float			s_fSi					: CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;

#ifdef	MIKUMIKUMOVING
#define	DECL_CUBE_RT( name, w, h, direction )							\
texture2D name	: OFFSCREENRENDERTARGET <								\
	string	Description		= "OffScreen RenderTarget for DualFishEye";	\
	int		Width			= w;										\
	int		Height			= h;										\
	float4	ClearColor		= { 0, 0, 0, 0 };							\
	float	ClearDepth		= 1.0;										\
	bool	AntiAlias		= true;										\
	string	DefaultEffect	=											\
		"self = hide;"													\
		"*=Sub/MakeCube_"direction".fxsub;"								\
	;																	\
>
#else
#define	DECL_CUBE_RT( name, w, h, direction )							\
texture2D name	: OFFSCREENRENDERTARGET <								\
	string	Description		= "OffScreen RenderTarget for DualFishEye";	\
	int		Width			= w;										\
	int		Height			= h;										\
	float4	ClearColor		= { 0, 0, 0, 0 };							\
	float	ClearDepth		= 1.0;										\
	bool	AntiAlias		= true;										\
	string	DefaultEffect	=											\
		"self = hide;"													\
		"WorkingFloorX.x = WorkingFloorX_v004/IA_WorkingFloorX_"direction".fxsub;"	\
		"*=Sub/MakeCube_"direction".fxsub;"								\
	;																	\
>
#endif


#define	DECL_SAMPLER( _name, _texture, _filter, _address )	\
sampler _name = sampler_state {								\
	Texture		= <_texture>;								\
	Filter		= _filter;									\
	AddressU	= _address;									\
	AddressV	= _address;									\
}


DECL_CUBE_RT( RT_CubeF, RT_SIZE, RT_SIZE, "F" );
DECL_CUBE_RT( RT_CubeB, RT_SIZE, RT_SIZE, "B" );
DECL_CUBE_RT( RT_CubeL, RT_SIZE, RT_SIZE, "L" );
DECL_CUBE_RT( RT_CubeR, RT_SIZE, RT_SIZE, "R" );
DECL_CUBE_RT( RT_CubeU, RT_SIZE, RT_SIZE, "U" );
DECL_CUBE_RT( RT_CubeD, RT_SIZE, RT_SIZE, "D" );

DECL_SAMPLER( smpCubeF, RT_CubeF, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeB, RT_CubeB, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeL, RT_CubeL, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeR, RT_CubeR, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeU, RT_CubeU, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeD, RT_CubeD, LINEAR, CLAMP );


float4	VS_LT( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.xy	= Pos.xy * sz - (float2(1,-1) * (1-sz));
	return	Pos;
}
float4	VS_RT( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.xy	= Pos.xy * sz - (float2(-1,-1) * (1-sz));
	return	Pos;
}
float4	VS_LB( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.xy	= Pos.xy * sz - (float2(1,1) * (1-sz));
	return	Pos;
}
float4	VS_RB( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.xy	= Pos.xy * sz - (float2(-1,1) * (1-sz));
	return	Pos;
}
float4	VS_L( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.x	= Pos.x * sz - (+1 * (1-sz));
	return	Pos;
}
float4	VS_R( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	float	sz	= clamp( s_fSi*0.1, 0.0, 1.0 );
	Pos.x	= Pos.x * sz - (-1 * (1-sz));
	return	Pos;
}
float4	VS( float4 Pos : POSITION, inout float2 Tex : TEXCOORD0 ) : POSITION {
	return	Pos;
}

float2			s_vViewportSize			: VIEWPORTPIXELSIZE;

float4	Cube( float3 vNormal ) {
	float2	uv;
	float3	vAbs	= abs( vNormal );
	float4	color;

	if( vAbs.x > vAbs.y && vAbs.x > vAbs.z ) {
		uv	= vNormal.yz / vNormal.x;
		if( vNormal.x > 0.0 ) {
			uv		= uv.yx * float2(-0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeR, uv );
		}
		else {
			uv		= uv.yx * float2(-0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeL, uv );
		}
	}
	else if( vAbs.y > vAbs.x && vAbs.y > vAbs.z ) {
		uv	= vNormal.xz / vNormal.y;
		if( vNormal.y > 0.0 ) {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeU, uv );
		}
		else {
			uv		= uv * float2(-0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeD, uv );
		}
	}
	else {
		uv	= vNormal.xy / vNormal.z;
		if( vNormal.z > 0.0 ) {
			uv		= uv * float2(0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeF, uv );
		}
		else {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeB, uv );
		}
	}
//	clip(s_fTr-fLength);
	return	color;
}

float4  Panorama360( float2 vTex ) {
	float3	vNormal;
	float2	csu,csv;

	vTex.x	+= 0.5;
	csu		= sin( float2( vTex.x * 3.1415926 * 2.0, vTex.x * 3.1415926 * 2.0 + 3.1415926*0.5 ) );
	csv		= sin( float2( (vTex.y * 2.0-1.0) * 3.1415926*0.5, (vTex.y * 2.0-1.0) * 3.1415926*0.5 + 3.1415926*0.5 ) );
	vNormal.x	= csu.x*csv.y;
	vNormal.z	= csu.y*csv.y;
	vNormal.y	= -csv.x;

	return	Cube( vNormal );
}

float4  DualFishEye( float2 vTex ) {
	float4	color;
	float3	vNormal;
	float3	vAbs;
	float2	uv;
	float	fSign;

	if( vTex.x < 0.5 ) {
		vTex.x	*= 2.0f;
		fSign	= -1.0;
	}
	else {
		vTex.x	= vTex.x * 2.0f - 1.0;
		fSign	= 1.0;
	}

	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( 0.5*s_vViewportSize.x / s_vViewportSize.y, 1.0, 0.0 ) * 0.5;

	float	fLength	= length( vNormal );
	float3	a		= normalize( float3( vNormal.y, -vNormal.x, 0.0 ) );
	float	s, c;

	sincos( 3.1415926 * fLength, s, c );
	vNormal.xyz	= fLength == 0.0	? float3( 0.0.xx, 1.0 )
									: float3( -a.yx * s, dot( a, a ) * c );
	vNormal.xz	*= fSign;

	clip( 0.5 - fLength );

	return	Cube( vNormal );
}


float4  AmaterasZ( float2 vTex ) {
	float4	color;
	float3	vNormal;
	float3	vAbs;
	float2	uv;

//	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( s_vViewportSize.x / s_vViewportSize.y, 1.0, 0.0 ) * 0.5;
	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( 1.0, 1.0, 0.0 ) * 0.5;

	float	fLength	= length( vNormal );
	float3	a		= normalize( float3( vNormal.y, -vNormal.x, 0.0 ) );
	float	s, c;

	sincos( 3.1415926 * fLength, s, c );
	vNormal.xyz	= fLength == 0.0	? float3( 0.0.xx, 1.0 )
									: float3( -a.yx * s, dot( a, a ) * c );
	vNormal		= vNormal.xzy;
	vNormal.z	*= -1;

	vAbs		= abs( vNormal );

	if( vAbs.x > vAbs.y && vAbs.x > vAbs.z ) {
		uv	= vNormal.yz / vNormal.x;
		if( vNormal.x > 0.0 ) {
			uv		= uv.yx * float2(-0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeR, uv );
		}
		else {
			uv		= uv.yx * float2(-0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeL, uv );
		}
	}
	else if( vAbs.y > vAbs.x && vAbs.y > vAbs.z ) {
		uv	= vNormal.xz / vNormal.y;
		if( vNormal.y > 0.0 ) {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeU, uv );
		}
		else {
			color	= 0;
		}
	}
	else {
		uv	= vNormal.xy / vNormal.z;
		if( vNormal.z > 0.0 ) {
			uv		= uv * float2(0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeF, uv );
		}
		else {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeB, uv );
		}
	}
	clip( 0.5 - fLength );
	return	color;
}


float4  PS_Amateras( float2 vTex : TEXCOORD0 ) : COLOR0
{
	return	float4( AmaterasZ( vTex ).xyz, s_fTr );
}


float4  PS_Panorama360( float2 vTex : TEXCOORD0 ) : COLOR0
{
	return	float4( Panorama360( vTex ).xyz, s_fTr );
}

float4  PS_DualFishEye( float2 vTex : TEXCOORD0 ) : COLOR0
{
	return	float4( DualFishEye( vTex ).xyz, s_fTr );
}

technique Tech {
	pass Draw_DualFishEye < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable	= FALSE;
		AlphaTestEnable		= FALSE;
		ZEnable				= FALSE;
		VertexShader		= compile vs_3_0 VS_LB();
		PixelShader			= compile ps_3_0 PS_DualFishEye();
	}
}

