//--------------------------------------------------------------------------------------
//
//	O㍶E㉺̂Uʂ`悵Ăgĉ`
//	by Caeru
//
//--------------------------------------------------------------------------------------

#define			RT_SIZE					800

#ifdef	MIKUMIKUMOVING

#define	DECL_CUBE_RT( name, w, h, direction )							\
texture2D name	: OFFSCREENRENDERTARGET <								\
	string	Description		= "OffScreen RenderTarget for InvAmateras";	\
	int		Width			= w;										\
	int		Height			= h;										\
	float4	ClearColor		= { 0, 0, 0, 0 };							\
	float	ClearDepth		= 1.0;										\
	bool	AntiAlias		= true;										\
	string	DefaultEffect	=											\
		"self = hide;"													\
		"*=Sub/MakeCube_"direction".fxsub;"								\
	;																	\
>

#else

#define	DECL_CUBE_RT( name, w, h, direction )							\
texture2D name	: OFFSCREENRENDERTARGET <								\
	string	Description		= "OffScreen RenderTarget for InvAmateras";	\
	int		Width			= w;										\
	int		Height			= h;										\
	float4	ClearColor		= { 0, 0, 0, 0 };							\
	float	ClearDepth		= 1.0;										\
	bool	AntiAlias		= true;										\
	string	DefaultEffect	=											\
		"self = hide;"													\
		"WorkingFloorX.x = WorkingFloorX_v004/IA_WorkingFloorX_"direction".fxsub;"	\
		"*=Sub/MakeCube_"direction".fxsub;"								\
	;																	\
>
#endif

#define	DECL_SAMPLER( _name, _texture, _filter, _address )	\
sampler _name = sampler_state {								\
	Texture		= <_texture>;								\
	Filter		= _filter;									\
	AddressU	= _address;									\
	AddressV	= _address;									\
}


DECL_CUBE_RT( RT_CubeF, RT_SIZE, RT_SIZE, "F" );
DECL_CUBE_RT( RT_CubeB, RT_SIZE, RT_SIZE, "B" );
DECL_CUBE_RT( RT_CubeL, RT_SIZE, RT_SIZE, "L" );
DECL_CUBE_RT( RT_CubeR, RT_SIZE, RT_SIZE, "R" );
DECL_CUBE_RT( RT_CubeU, RT_SIZE, RT_SIZE, "U" );

DECL_SAMPLER( smpCubeF, RT_CubeF, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeB, RT_CubeB, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeL, RT_CubeL, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeR, RT_CubeR, LINEAR, CLAMP );
DECL_SAMPLER( smpCubeU, RT_CubeU, LINEAR, CLAMP );


struct VS_OUTPUT {
	float4	Pos		: POSITION;
	float2	Tex		: TEXCOORD0;
};

VS_OUTPUT VS( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ){
	VS_OUTPUT	Out;

	Out.Pos		= Pos;
	Out.Tex		= Tex;
	return	Out;
}

float2			s_vViewportSize			: VIEWPORTPIXELSIZE;

float4  AmaterasZ( float2 vTex, float3x3 mtxAdjust, float3 vSign ) {
	float4	color;
	float3	vNormal;
	float3	vAbs;
	float2	uv;

	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( s_vViewportSize.x / s_vViewportSize.y, 1.0, 0.0 ) * 0.5;

	float	fLength	= length( vNormal );
	float3	a		= normalize( float3( vNormal.y, -vNormal.x, 0.0 ) );
	float	s, c;

	sincos( 3.1415926 * fLength, s, c );
	vNormal.xyz	= fLength == 0.0	? float3( 0.0.xx, 1.0 )
									: float3( -a.yx * s, dot( a, a ) * c );

	vNormal		*= vSign;
	vNormal		= mul( vNormal, mtxAdjust );
	vAbs		= abs( vNormal );

	if( vAbs.x > vAbs.y && vAbs.x > vAbs.z ) {
		uv	= vNormal.yz / vNormal.x;
		if( vNormal.x > 0.0 ) {
			uv		= uv.yx * float2(-0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeR, uv );
		}
		else {
			uv		= uv.yx * float2(-0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeL, uv );
		}
	}
	else if( vAbs.y > vAbs.x && vAbs.y > vAbs.z ) {
		uv	= vNormal.xz / vNormal.y;
		if( vNormal.y > 0.0 ) {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeU, uv );
		}
		else {
			color	= 0;
		}
	}
	else {
		uv	= vNormal.xy / vNormal.z;
		if( vNormal.z > 0.0 ) {
			uv		= uv * float2(0.5,-0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeF, uv );
		}
		else {
			uv		= uv * float2(0.5,0.5) + 0.5;
			uv		*= (RT_SIZE-1.0) / RT_SIZE;
			uv		+= 0.5 / (RT_SIZE-1.0);
			color	= tex2D( smpCubeB, uv );
		}
	}
	clip(0.5-fLength);
	return	color;
}


float4  PS_Amateras( float2 vTex : TEXCOORD0 ) : COLOR0
{
	float3x3	mtxAdj	= {
		float3( 1, 0, 0 ),
		float3( 0, 0, 1 ),
		float3( 0, 1, 0 ),
	};
	return	AmaterasZ( vTex, mtxAdj, float3( 1.0, -1.0, 1.0 ) );
}

float4  PS_AmaterasZ( float2 vTex : TEXCOORD0 ) : COLOR0
{
	float3x3	mtxAdj	= {
		float3( 1, 0, 0 ),
		float3( 0, 1, 0 ),
		float3( 0, 0, 1 ),
	};
	return	AmaterasZ( vTex, mtxAdj, float3( 1.0, 1.0, 1.0 ) );
}

technique Amateras <
    string Script = 
		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"Pass=Draw_Amateras;"
    ;
> {
	pass Draw_Amateras < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable	= FALSE;
		AlphaTestEnable		= FALSE;
		ZEnable				= FALSE;
		VertexShader		= compile vs_3_0 VS();
		PixelShader			= compile ps_3_0 PS_Amateras();
	}
}

