//--------------------------------------------------------------------------------------
//
//	|XgInvAmateras
//	by Caeru
//
//--------------------------------------------------------------------------------------


float Script : STANDARDSGLOBAL <
	string ScriptOutput	= "color";
	string ScriptClass	= "scene";
	string ScriptOrder	= "postprocess";
> = 0.8;


texture2D	DepthBuffer		: RENDERDEPTHSTENCILTARGET <
	float2	ViewPortRatio	= {1.0,1.0};
	string	Format			= "D24S8";
>;

texture2D	tgtScreenMap	: RENDERCOLORTARGET <
	float2	ViewPortRatio	= {1.0,1.0};
	int		MipLevels		= 1;
	string	Format			= "A8R8G8B8";
>;

sampler2D	smpScreen		= sampler_state {
	texture		= <tgtScreenMap>;
	MinFilter	= NONE;
	MagFilter	= LINEAR;
	MipFilter	= NONE;
	AddressU	= CLAMP;
	AddressV	= CLAMP;
};

struct VS_OUTPUT {
	float4	Pos		: POSITION;
	float2	Tex		: TEXCOORD0;
};

VS_OUTPUT VS( float4 Pos : POSITION, float2 Tex : TEXCOORD0 ){
	VS_OUTPUT	Out;

	Out.Pos		= Pos;
	Out.Tex		= Tex;
	return	Out;
}

float2			s_vViewportSize			: VIEWPORTPIXELSIZE;
float4x4		matProj					: PROJECTION;
static float	cotX					= matProj._11;
static float	cotY					= matProj._22;
static float	tanX					= 1.0/cotX;
static float	tanY					= 1.0/cotY;
static float	fovX2					= atan( tanX );
static float	fovY2					= atan( tanY );
static float	fovX					= 2.0 * fovX2;
static float	fovY					= 2.0 * fovY2;
static float	s_fCos					= cos( fovY2 );
static float	s_fSin					= sin( fovY2 );

float4  PS_PostInvAmateras( float2 vTex : TEXCOORD0 ) : COLOR0
{
	float4	color;
	float3	vNormal;
	float2	uv;

//	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( s_vViewportSize.x / s_vViewportSize.y, 1.0, 0.0 ) * 0.5;
	vNormal.xyz	= (vTex.xyy * 2.0 - 1.0) * float3( 1.0, -1.0, 0.0 ) * 0.5;
	float	fLength	= length( vNormal );
	float2	angle;
	float2	s, c;
	angle.x	= fLength * 3.1415926;
	angle.y	= atan2( vNormal.y, vNormal.x );
	sincos( angle, s, c );
	vNormal.xyz	=  float3( c.y * s.x, s.y * s.x, c.x );
	vNormal.yz	= vNormal.y * float2( s_fCos, s_fSin ) + vNormal.z * float2( -s_fSin, s_fCos );
	vNormal		= vNormal.xzy * float3( 1, 1, -1 );

	color	= 0;
	if( vNormal.z > 0.0 ) {
		uv		= vNormal.xy * float2( cotX, cotY ) / vNormal.z;
		uv		= uv * float2(0.5,-0.5) + 0.5;
		color	= tex2D( smpScreen, uv ) * all( saturate( uv ) == uv );
	}

	return	color;
}

float4	ClearColor	= 0.0;
float	ClearDepth	= 1.0;

technique Amateras <
    string Script = 
		"RenderColorTarget0=tgtScreenMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"ScriptExternal=Color;"

		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"Pass=Draw_PostInvAmateras;"
    ;
> {
	pass Draw_PostInvAmateras < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable	= FALSE;
		AlphaTestEnable		= FALSE;
		ZEnable				= FALSE;
		VertexShader		= compile vs_3_0 VS();
		PixelShader			= compile ps_3_0 PS_PostInvAmateras();
	}
}

