////////////////////////////////////////////////////////////////////////////////////////////////
//
//  full.fx ver2.0
//  쐬: ͉P
//
////////////////////////////////////////////////////////////////////////////////////////////////
//
//	full.fxySampleBase.fxmx[XɂăJȂǂ㏑Œʏ̃f̕`揈
//	by Caeru
//
////////////////////////////////////////////////////////////////////////////////////////////////


//	Wϊ
DECL_CAMERA_POSITION( CameraPosition );
DECL_VIEW_MATRIX	( s_mtxView );
DECL_PROJ_MATRIX	( s_mtxProj );
DECL_VIEWPROJ		( s_mtxViewProj );
DECL_WORLD_MATRIX	( WorldMatrix );
DECL_VIEW_MATRIX	( ViewMatrix );
DECL_WORLDVIEWPROJ	( WorldViewProjMatrix );
DECL_WORLDVIEWPROJ	( WorldViewProjShadow );


float4x4	AxisRotation( float3 vAxis, float fAngle ) {
	if( dot( abs( vAxis ), 1 ) <= 0.01 ) {
		return	float4x4(	float4( 1, 0, 0, 0 ),
							float4( 0, 1, 0, 0 ),
							float4( 0, 0, 1, 0 ),
							float4( 0, 0, 0, 1 ) );
	}
	else {
		float3		a	= normalize( vAxis );
		float3		sq	= a * a;
		float		s, c;

		sincos( fAngle, s, c );

		float4x4	r;
		r._11_21_31_41	= float4( sq.x + (sq.y + sq.z) * c,		a.x * a.y * (1-c) - a.z * s,	a.x * a.z * (1-c) + a.y * s,	0.0 );
		r._12_22_32_42	= float4( a.x * a.y * (1-c) + a.z * s,	sq.y + (sq.x + sq.z) * c,		a.y * a.z * (1-c) - a.x * s,	0.0 );
		r._13_23_33_43	= float4( a.x * a.z * (1-c) - a.y * s,	a.y * a.z * (1-c) + a.x * s,	sq.z + (sq.x + sq.y) * c,		0.0 );
		r._14_24_34_44	= float4( 0.0.xxx, 1.0 );
		return r;
	}
}



float4x4		LightWorldViewProjMatrix	: WORLDVIEWPROJECTION < string Object = "Light"; >;
float3			LightDirection				: DIRECTION < string Object = "Light"; >;

//	}eAF
float4			MaterialDiffuse				: DIFFUSE  < string Object = "Geometry"; >;
float3			MaterialAmbient				: AMBIENT  < string Object = "Geometry"; >;
float3			MaterialEmmisive			: EMISSIVE < string Object = "Geometry"; >;
float3			MaterialSpecular			: SPECULAR < string Object = "Geometry"; >;
float			SpecularPower				: SPECULARPOWER < string Object = "Geometry"; >;
float3			MaterialToon				: TOONCOLOR;
float4			EdgeColor					: EDGECOLOR;
float4			GroundShadowColor			: GROUNDSHADOWCOLOR;

//	CgF
float3			LightDiffuse				: DIFFUSE   < string Object = "Light"; >;
float3			LightAmbient				: AMBIENT   < string Object = "Light"; >;
float3			LightSpecular				: SPECULAR  < string Object = "Light"; >;
static float4	DiffuseColor				= MaterialDiffuse  * float4(LightDiffuse, 1.0f);
static float3	AmbientColor				= MaterialAmbient  * LightAmbient + MaterialEmmisive;
static float3	SpecularColor				= MaterialSpecular * LightSpecular;

//	eNX`ގ[tl
float4			TextureAddValue				: ADDINGTEXTURE;
float4			TextureMulValue				: MULTIPLYINGTEXTURE;
float4			SphereAddValue				: ADDINGSPHERETEXTURE;
float4			SphereMulValue				: MULTIPLYINGSPHERETEXTURE;

bool	use_subtexture;		//	TueNX`tO

bool	parthf;				//	p[XyNeButO
bool	transp;				//	tO
bool	spadd;				//	XtBA}bvZtO
#define SKII1	1500
#define SKII2	8000
#define Toon	3


//	IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture		= <ObjectTexture>;
	MINFILTER	= LINEAR;
	MAGFILTER	= LINEAR;
//	MIPFILTER	= LINEAR;
	MIPFILTER	= NONE;
	ADDRESSU	= WRAP;
	ADDRESSV	= WRAP;
};

//	XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
	texture		= <ObjectSphereMap>;
	MINFILTER	= LINEAR;
	MAGFILTER	= LINEAR;
	MIPFILTER	= LINEAR;
	ADDRESSU	= WRAP;
	ADDRESSV	= WRAP;
};

// gD[}bṽeNX`
texture ObjectToonTexture: MATERIALTOONTEXTURE;
sampler ObjToonSampler = sampler_state {
	texture		= <ObjectToonTexture>;
	MINFILTER	= LINEAR;
	MAGFILTER	= LINEAR;
	MIPFILTER	= NONE;
	ADDRESSU	= CLAMP;
	ADDRESSV	= CLAMP;
};


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT {
	float4	Pos			: POSITION;		//	ˉeϊW
	float2	Tex			: TEXCOORD1;	//	eNX`
	float3	Normal		: TEXCOORD2;	//	@
	float3	Eye			: TEXCOORD3;	//	JƂ̑Έʒu
	float2	SpTex		: TEXCOORD4;	//	XtBA}bveNX`W
	float4	Color		: COLOR0;		//	fBt[YF
	float3	Specular	: COLOR1;		//	XyLF
};

//	_VF[_
VS_OUTPUT	Basic_VS( MM_INPUT Input, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
	MM_LOCAL	Local	= MMTransform( Input );
	VS_OUTPUT	Out	= (VS_OUTPUT)0;

	//	J_̃[hr[ˉeϊ
	Out.Pos			= mul( Local.Position, WorldViewProjMatrix );

	//	JƂ̑Έʒu
	Out.Eye			= CameraPosition - mul( Local.Position, WorldMatrix );
	//	_@
	Out.Normal		= normalize( mul( Local.Normal, (float3x3)WorldMatrix ) );

	//	fBt[YF{ArGgF vZ
	Out.Color.rgb	= AmbientColor;
	if ( !useToon ) {
		Out.Color.rgb	+= max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
	}
	Out.Color.a		= DiffuseColor.a;
	Out.Color		= saturate( Out.Color );

	//	eNX`W
	Out.Tex			= Input.Tex;

	if( useSphereMap ) {
		if( use_subtexture ) {	//	PMXTueNX`W
			Out.SpTex	= Input.AddUV1;
		} else {				//	XtBA}bveNX`W
		//	Out.SpTex	= mul( Out.Normal, (float3x3)ViewMatrix ) * float2( 0.5, -0.5 ) + 0.5;
			float3		vNormal	= Out.Normal;
			float3		vCamToP	= normalize( -Out.Eye );
			float4x4	mtx		= AxisRotation( normalize( cross( vCamToP, float3( 0, 0, 1 ) ) ), acos( vCamToP.z ) );
			vNormal	= mul( Out.Normal, mtx );
			Out.SpTex	= vNormal.xy * float2( 0.5, -0.5 ) * 0.9 + 0.5;
		}
	}

	//	XyLFvZ
	float3	HalfVector	= normalize( normalize(Out.Eye) + -LightDirection );
	Out.Specular	= pow( max(0,dot( HalfVector, Out.Normal )), SpecularPower ) * SpecularColor;

	return Out;
}

//	sNZVF[_
float4	Basic_PS(VS_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR0
{
	float4	Color	= IN.Color;
	if( useTexture ) {		// eNX`Kp
		Color	*= tex2D( ObjTexSampler, IN.Tex );
	}
	if( useSphereMap ) {	// XtBA}bvKp
		float4	TexColor	= tex2D(ObjSphareSampler,IN.SpTex);
		if( spadd )	Color.rgb	+= TexColor.rgb;
		else		Color.rgb	*= TexColor.rgb;
		Color.a	*= TexColor.a;
	}
	clip( Color.a - 0.1 );

	if( useToon ) {	// gD[Kp
		float	LightNormal	= dot( IN.Normal, -LightDirection );
		Color	*= tex2D( ObjToonSampler, float2( 0, 0.5 - LightNormal * 0.5 ) );
	}

	//	XyLKp
	Color.rgb	+= IN.Specular;

	return Color;
}


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEONj

// VhEobt@̃TvB"register(s0)"Ȃ̂MMDs0gĂ邩
sampler DefSampler : register(s0);

struct BufferShadow_OUTPUT {
	float4	Pos			: POSITION;		//	ˉeϊW
	float4	ZCalcTex	: TEXCOORD0;	//	Zl
	float2	Tex			: TEXCOORD1;	//	eNX`
	float3	Normal		: TEXCOORD2;	//	@
	float3	Eye			: TEXCOORD3;	//	JƂ̑Έʒu
	float2	SpTex		: TEXCOORD4;	//	XtBA}bveNX`W
	float4	Color		: COLOR0;		//	fBt[YF
};

//	_VF[_
BufferShadow_OUTPUT BufferShadow_VS( MM_INPUT Input, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
	MM_LOCAL	Local	= MMTransform( Input );
	BufferShadow_OUTPUT Out = (BufferShadow_OUTPUT)0;

	//	J_̃[hr[ˉeϊ
	Out.Pos			= mul( Local.Position, WorldViewProjMatrix );

	//	JƂ̑Έʒu
	Out.Eye			= CameraPosition - mul( Local.Position, WorldMatrix );
	//	_@
	Out.Normal		= normalize( mul( Local.Normal, (float3x3)WorldMatrix ) );
	//	Cg_ɂ郏[hr[ˉeϊ
	Out.ZCalcTex	= mul( Local.Position, LightWorldViewProjMatrix );

	//	fBt[YF{ArGgF vZ
	Out.Color.rgb	= AmbientColor;
	if( !useToon ) {
		Out.Color.rgb	+= max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
	}
	Out.Color.a		= DiffuseColor.a;
	Out.Color		= saturate( Out.Color );

	//	eNX`W
	Out.Tex			= Input.Tex;

	if( useSphereMap ) {
		if( use_subtexture ) {	//	PMXTueNX`W
			Out.SpTex	= Input.AddUV1;
		} else {				//	XtBA}bveNX`W
		//	Out.SpTex	= mul( Out.Normal, (float3x3)ViewMatrix ) * float2( 0.5, -0.5 ) + 0.5;
			float3		vNormal	= Out.Normal;
			float3		vCamToP	= normalize( -Out.Eye );
			float4x4	mtx		= AxisRotation( normalize( cross( vCamToP, float3( 0, 0, 1 ) ) ), acos( vCamToP.z ) );
			vNormal	= mul( Out.Normal, mtx );
			Out.SpTex	= vNormal.xy * float2( 0.5, -0.5 ) * 0.9 + 0.5;
		}
	}

	return Out;
}

//	sNZVF[_
float4 BufferShadow_PS(BufferShadow_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{
	//	XyLFvZ
	float3	HalfVector	= normalize( normalize(IN.Eye) + -LightDirection );
	float3	Specular	= pow( max(0,dot( HalfVector, normalize(IN.Normal) )), SpecularPower ) * SpecularColor;

	float4	Color		= IN.Color;
	float4	ShadowColor	= float4( saturate(AmbientColor), Color.a );	// e̐F
	if( useTexture ) {
		//	eNX`Kp
		float4 TexColor	= tex2D( ObjTexSampler, IN.Tex );
		//	eNX`ގ[t
		TexColor.rgb	= lerp(1, TexColor * TextureMulValue + TextureAddValue, TextureMulValue.a + TextureAddValue.a);
		Color			*= TexColor;
		ShadowColor		*= TexColor;
	}
	if( useSphereMap ) {
		// XtBA}bvKp
		float4	TexColor	= tex2D(ObjSphareSampler,IN.SpTex);
		// XtBAeNX`ގ[t
		TexColor.rgb		= lerp(spadd?0:1, TexColor * SphereMulValue + SphereAddValue, SphereMulValue.a + SphereAddValue.a);
		if(spadd) {
			Color.rgb		+= TexColor.rgb;
			ShadowColor.rgb	+= TexColor.rgb;
		} else {
			Color.rgb		*= TexColor.rgb;
			ShadowColor.rgb	*= TexColor.rgb;
		}
		Color.a			*= TexColor.a;
		ShadowColor.a	*= TexColor.a;
	}

	clip( Color.a - 0.1 );

	// XyLKp
	Color.rgb += Specular;

	// eNX`Wɕϊ
	IN.ZCalcTex /= IN.ZCalcTex.w;
	float2 TransTexCoord;
	TransTexCoord	= IN.ZCalcTex * float2( 0.5, -0.5 ) + 0.5;

	if( all( saturate( TransTexCoord ) == TransTexCoord ) ) {
		float	sk		= parthf ? SKII2*TransTexCoord.y : SKII1;
		float	comp	= 1-saturate( max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f) * sk-0.3f );

		if( useToon ) {		// gD[Kp
			comp	= min( saturate( dot( IN.Normal, -LightDirection )*Toon ), comp );
			ShadowColor.rgb	*= MaterialToon;
		}

		Color	= lerp( ShadowColor, Color, comp );
		if( transp )Color.a = 0.5;
	}
	return	Color;
}


////////////////////////////////////////////////////////////////////////////////////////////////
//	֊s`
float4	Edge_VS( MM_INPUT Input ) : POSITION 
{
	MM_LOCAL	Local	= MMTransform( Input );
	return mul( Local.Position, WorldViewProjMatrix );	//	J_̃[hr[ˉeϊ
}

///////////////////////////////////////////////////////////////////////////////////////////////
//	eiZtVhEj`
float4 Shadow_VS( MM_INPUT Input ) : POSITION
{
	MM_LOCAL	Local	= MMTransform( Input );
	return mul( Local.Position, WorldViewProjShadow );	//	J_̃[hr[ˉeϊ
}

float4	ColorFill_PS( uniform float4 vColor ) : COLOR {		return	vColor;		}


///////////////////////////////////////////////////////////////////////////////////////////////
// ZtVhEpZlvbg

struct VS_ZValuePlot_OUTPUT {
	float4	Pos				: POSITION;		// ˉeϊW
	float4	ShadowMapTex	: TEXCOORD0;	// Zobt@eNX`
};

//	_VF[_
VS_ZValuePlot_OUTPUT	ZValuePlot_VS( MM_INPUT Input ) {
	MM_LOCAL	Local	= MMTransform( Input );
	VS_ZValuePlot_OUTPUT Out = (VS_ZValuePlot_OUTPUT)0;

	//	Cg̖ڐɂ郏[hr[ˉeϊ
	Out.Pos				= mul( Local.Position, LightWorldViewProjMatrix );

	//	eNX`W𒸓_ɍ킹
	Out.ShadowMapTex	= Out.Pos;

	return Out;
}

// sNZVF[_
float4 ZValuePlot_PS( float4 ShadowMapTex : TEXCOORD0 ) : COLOR
{
	//	RFZlL^
	return	float4( ShadowMapTex.z/ShadowMapTex.w, 0, 0, 1 );
}

#if	0

#define	DECL_TECH_NS( _TechName, _bTex, _bSph, _bToon )																				\
technique _TechName < string MMDPass = "object"; bool UseTexture = _bTex; bool UseSphereMap = _bSph; bool UseToon = _bToon; > {		\
	pass DrawObject {																												\
		VertexShader	= compile vs_3_0 Basic_VS( _bTex, _bSph, _bToon );															\
		PixelShader		= compile ps_3_0 Basic_PS( _bTex, _bSph, _bToon );															\
	}																																\
}

#define	DECL_TECH_BS( _TechName, _bTex, _bSph, _bToon )																				\
technique _TechName < string MMDPass = "object_ss"; bool UseTexture = _bTex; bool UseSphereMap = _bSph; bool UseToon = _bToon; > {	\
	pass DrawObject {																												\
		VertexShader	= compile vs_3_0 BufferShadow_VS( _bTex, _bSph, _bToon );													\
		PixelShader		= compile ps_3_0 BufferShadow_PS( _bTex, _bSph, _bToon );													\
	}																																\
}

DECL_TECH_NS( MainTechNS0, false, false, false )
DECL_TECH_NS( MainTechNS1, true,  false, false )
DECL_TECH_NS( MainTechNS2, false, true,  false )
DECL_TECH_NS( MainTechNS3, true,  true,  false )
DECL_TECH_NS( MainTechNS4, false, false, true  )
DECL_TECH_NS( MainTechNS5, true,  false, true  )
DECL_TECH_NS( MainTechNS6, false, true,  true  )
DECL_TECH_NS( MainTechNS7, true,  true,  true  )

DECL_TECH_BS( MainTechBS0, false, false, false )
DECL_TECH_BS( MainTechBS1, true,  false, false )
DECL_TECH_BS( MainTechBS2, false, true,  false )
DECL_TECH_BS( MainTechBS3, true,  true,  false )
DECL_TECH_BS( MainTechBS4, false, false, true  )
DECL_TECH_BS( MainTechBS5, true,  false, true  )
DECL_TECH_BS( MainTechBS6, false, true,  true  )
DECL_TECH_BS( MainTechBS7, true,  true,  true  )
#else

bool			use_texture;		//	eNX`tO
bool			use_spheremap;		//	XtBAtO
bool			use_toon;			//	gD[tO

technique TechObjNS < string MMDPass = "object"; > {
	pass DrawObject {
		VertexShader	= compile vs_3_0 Basic_VS( use_texture, use_spheremap, use_toon );
		PixelShader		= compile ps_3_0 Basic_PS( use_texture, use_spheremap, use_toon );
	}
}
technique TechObjBS < string MMDPass = "object_ss"; > {
	pass DrawObject {
		VertexShader	= compile vs_3_0 BufferShadow_VS( use_texture, use_spheremap, use_toon );
		PixelShader		= compile ps_3_0 BufferShadow_PS( use_texture, use_spheremap, use_toon );
	}
}
#endif

//	֊s`peNjbN
technique EdgeTec < string MMDPass = "edge"; > {
	pass DrawEdge {
		VertexShader	= compile vs_2_0 Edge_VS();
		PixelShader		= compile ps_2_0 ColorFill_PS( EdgeColor );
	}
}

//	e`peNjbN
technique ShadowTec < string MMDPass = "shadow"; > {
	pass DrawShadow {
		VertexShader	= compile vs_2_0 Shadow_VS();
		PixelShader		= compile ps_2_0 ColorFill_PS( GroundShadowColor );
	}
}

//	ZlvbgpeNjbN
technique ZplotTec < string MMDPass = "zplot"; > {
	pass ZValuePlot {
		AlphaBlendEnable= FALSE;
		VertexShader	= compile vs_2_0 ZValuePlot_VS();
		PixelShader		= compile ps_2_0 ZValuePlot_PS();
	}
}


