#ifndef	__INVERSE_AMATERAS_UTIL_HEADER_INCLUDED__
#define	__INVERSE_AMATERAS_UTIL_HEADER_INCLUDED__


float4x4		s_mtxOriginalView		: VIEW;
float4x4		s_mtxOriginalWorld		: WORLD;
float4x4		s_mtxOrgProjection		: PROJECTION;
float4x4	InvAmateras_Make45Projection() {
	float4	l0		= s_mtxOrgProjection._11_12_13_14;
	float4	l1		= s_mtxOrgProjection._21_22_23_24;
	float4	l2		= s_mtxOrgProjection._31_32_33_34;
	float4	l3		= s_mtxOrgProjection._41_42_43_44;
	l0.x	= 1.0;
	l1.y	= 1.0;
	return	float4x4( l0, l1, l2, l3 );
}


bool		s_bInvAmateras			: CONTROLOBJECT < string name = "InvAmateras.x"; >;
bool		s_bInvAmateras512		: CONTROLOBJECT < string name = "InvAmateras-512.x"; >;
bool		s_bInvAmateras2048		: CONTROLOBJECT < string name = "InvAmateras-2048.x"; >;
bool		s_bPanorama360			: CONTROLOBJECT < string name = "Panorama360.x"; >;
bool		s_bPanorama360Box		: CONTROLOBJECT < string name = "Panorama360Box.pmx"; >;
bool		s_bDualFishEye			: CONTROLOBJECT < string name = "DualFishEye.x"; >;
float4x4	s_mtxInvAmateras		: CONTROLOBJECT < string name = "InvAmateras.x"; >;
float4x4	s_mtxInvAmateras512		: CONTROLOBJECT < string name = "InvAmateras-512.x"; >;
float4x4	s_mtxInvAmateras2048	: CONTROLOBJECT < string name = "InvAmateras-2048.x"; >;
float4x4	s_mtxPanorama360		: VIEWINVERSE	< string Object = "Camera"; >;
float4x4	s_mtxPanorama360Box		: CONTROLOBJECT < string name = "Panorama360Box.pmx"; string item = "_"; >;
float4x4	s_mtxDualFishEye		: CONTROLOBJECT < string name = "DualFishEye.x"; >;

float4x4		GetOwnerWorld( void ) {
	float4x4	mtx;

	if( s_bInvAmateras ) {
		mtx	= s_mtxInvAmateras;
	}
#if	0
	else if( s_bInvAmateras512 ) {
		mtx	= s_mtxInvAmateras512;
	}
	else if( s_bInvAmateras2048 ) {
		mtx	= s_mtxInvAmateras2048;
	}
#endif
	else if( s_bPanorama360 ) {
		mtx	= s_mtxPanorama360;
	}
	else if( s_bPanorama360Box ) {
		mtx	= s_mtxPanorama360Box;
	}
	else if( s_bDualFishEye ) {
		mtx	= s_mtxDualFishEye;
	}
	return	mtx;
}

static float4x4	s_mtxOwnerWorld			= GetOwnerWorld();
static float4x4	s_mtxOwnerView			= float4x4	(
														float4( normalize( s_mtxOwnerWorld._11_21_31 ), 0.0 ),
														float4( normalize( s_mtxOwnerWorld._12_22_32 ), 0.0 ),
														float4( normalize( s_mtxOwnerWorld._13_23_33 ), 0.0 ),
														float4(	-dot( normalize( s_mtxOwnerWorld._11_12_13 ), s_mtxOwnerWorld._41_42_43 ),
																-dot( normalize( s_mtxOwnerWorld._21_22_23 ), s_mtxOwnerWorld._41_42_43 ),
																-dot( normalize( s_mtxOwnerWorld._31_32_33 ), s_mtxOwnerWorld._41_42_43 ),
																1.0 )
													);

static float3	s_vCameraPosition		= s_mtxOwnerWorld._41_42_43;
static float4x4	s_mtxBaseView			= s_mtxOwnerView;
static float4x4	s_mtxCubeView			= mul( s_mtxBaseView, s_mtxCube );


#define	DECL_CAMERA_POSITION( _name )	static float3	_name		= s_vCameraPosition
#define	DECL_WORLD_MATRIX( _name )		float4x4		_name		: WORLD
#define	DECL_VIEW_MATRIX( _name )		static float4x4	_name		= mul( s_mtxBaseView, s_mtxCube )
#define	DECL_PROJ_MATRIX( _name )		static float4x4	_name		= InvAmateras_Make45Projection()
#define	DECL_BASE_VIEW( _name )			static float4x4	_name		= s_mtxBaseView
#define	DECL_WORLDVIEW( _name )			static float4x4	_name		= mul( s_mtxOriginalWorld, mul( s_mtxBaseView, s_mtxCube ) )
#define	DECL_VIEWPROJ( _name )			static float4x4	_name		= mul( mul( s_mtxBaseView, s_mtxCube ), InvAmateras_Make45Projection() )
#define	DECL_WORLDVIEWPROJ( _name )		static float4x4	_name		= mul( s_mtxOriginalWorld, mul( mul( s_mtxBaseView, s_mtxCube ), InvAmateras_Make45Projection() ) )

#endif
